<template>
  <div class="card playTable">
    <div class="playTable_header">
      <div class="flex flex-between playTable_header-title">
        <span class="text">{{$t('playTable.title')}}</span>
        <img
          @click="copy"
          src="~/static/icons/copy.png"
          class="icon"
          alt="">
      </div>
      <div class="text-ellipsis color-white playTable_header-subtitle">
        {{hash}}
      </div>
    </div>
    <div
      class="playTable_body">
      <div
        id="grid"
        style="z-index: 2;"></div>
      <Grid></Grid>
      <FakeGrid style="position: absolute;left:0px;top:0px; z-index: 3;"></FakeGrid>
      <transition name="scale-fade">
        <GameUnderMaintain v-if="!gameEnabled"></GameUnderMaintain>
        <clockTrouble v-if="gameEnabled && clockTroubleState"></clockTrouble>
        <waitingLoader
          v-if="gameEnabled && !clockTroubleState && waitingState"></waitingLoader>
      </transition>
    </div>
    <div class="playTable_footer-wrapper">
      <div
        class="playTable_footer"
        :class="collapsed ? 'playTable_footer-collapsed': ''"
        @click="collapse">
        <div class="playTable_footer-inner flex">
          <MyBetProgress
            :myBetCount="myBetsCount"
            :myBetTotal="myBetsTotal">
            <Progress
              type="blue"
              :value="myProgress"></Progress>
          </MyBetProgress>
          <div
            class="playTable_footer-btn flex flex-middle flex-end">
            <div
              class="playTable_footer-btn-img-wrapper"
              v-show="collapsed">
              <img
                class="playTable_footer-btn-img rotated"
                src="~/static/icons/arrowCollapse-show.png"
                alt="">
            </div>
            <div
              class="playTable_footer-btn-img-wrapper"
              v-show="!collapsed">
              <img
                v-if="myBets.length"
                class="playTable_footer-btn-img"
                src="~/static/icons/arrowCollapse-show.png"
                alt="">
              <img
                v-else
                class="playTable_footer-btn-img"
                src="~/static/icons/arrowCollapse.png"
                alt="">
            </div>
          </div>
        </div>
        <div
          class="playTable_footer-bets"
          v-if="collapsedBets">
          <div
            class="playTable_footer-bets-item flex flex-middle flex-between"
            v-for="(item, key) in myBets"
            :key="key">
            <div
              class="playTable_footer-bets-number"
              :class="typeof item.number==='string' ? 'playTable_footer-bets-string' : ''">
              {{item.number}}
            </div>
            <div class="playTable_footer-bets-progress">
              <MyBetProgress
                :bet="item.amount"
                :win="item.win">
                <Progress
                  type="blue"
                  :value="item.progress"
                  small></Progress>
              </MyBetProgress>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!--<TheDialog></TheDialog>-->
  </div>
</template>

<script>
  import SvgGrid from '~/components/playTable/svgGrid';
  import Grid from './grid';
  import FakeGrid from './fakeGrid';
  import MyBetProgress from './MyBetProgress';
  import Progress from '~/components/UI/Progress';
  /*import TheDialog from './TheDialog';*/
  import copyClipboard from '~/components/utils/copy';
  import waitingLoader from './waitingLoader';
  import clockTrouble from './clockTrouble';
  import GameUnderMaintain from './GameUnderMaintain';
  import {mapState} from 'vuex';

  import {flooring} from "../utils";

  export default {
    name: "PlayTable",
    data() {
      return {
        collapsed: false,
        collapsedBets: false
      }
    },
    components: {
      Grid, MyBetProgress, Progress, waitingLoader, FakeGrid,
      clockTrouble, GameUnderMaintain
    },
    computed: {
      ...mapState({
        waitingState: state => state.common.waiting,
        clockTroubleState: state => state.common.clockTrouble,
        balance: state => state.wallet.balance,
        hash: state => state.game.currentGame.house_seed_hash,
        cap: state => state.game.settings.cap,
        cellLimit: state => state.game.settings.cell_limit,
        myBetsTotal: state => flooring(state.game.bets.myTotal),
        myBetsCount: state => state.game.bets.myCount,
        gameEnabled: state => state.game.globalGameSettings.game_enabled
      }),
      myProgress() {
        const limiter = this.cap / 24 / this.cellLimit;
        return (parseInt(this.myBetsTotal / (this.cap / limiter) * 10000) / 100) + '%';
      },
      myBets() {
        return this.$store.getters['game/myBets'];
      }
    },
    methods: {
      copy() {
        this.ga('copy');
        copyClipboard(this.hash, this.$t('common.copied'));
      },
      collapse() {
        if (!this.myBets.length) return;
        if (this.collapsed) {
          this.collapsedBets = false;
          this.collapsed = false;
        } else {
          this.collapsed = true;
          setTimeout(_ => this.collapsedBets = true, 300);
        }
        this.ga('ar', true);
      }
    },
    watch: {
      myBets: function () {
        if (!this.myBets.length) {
          this.collapsedBets = false;
          this.collapsed = false;
        }
      }
    },
    mounted() {
      const d = new SvgGrid('#grid');
      d.init();
    }
  }
</script>
